=== debian/changelog ===
amdsmi (7.0.2-2) unstable; urgency=medium

  * d/copyright: update for upstream license change to Expat/MIT

 -- Tim Flink <tflink@tirfa.com>  Wed, 29 Oct 2025 13:56:58 -0600

amdsmi (7.0.2-1) unstable; urgency=medium

  * New upstream version 7.0.2
  * refresh patches

 -- Mario Limonciello <superm1@gmail.com>  Tue, 28 Oct 2025 12:03:10 -0500
