=== debian/tests/control ===
Test-Command: /bin/bash debian/tests/amdsmi.sh
Depends: amd-smi,
Restrictions: skippable,
              allow-stderr,
              needs-root,
Features: test-name=run-amdsmi
Architecture: amd64

# Notes: this test causes error: cannot set terminal process group (-1): Inappropriate ioctl for device
# So disable this test as for now
# Test-Command: /usr/bin/bash debian/tests/upstream-binaries libamd-smi0-tests
# Depends: libamd-smi0-tests,
# Restrictions: skippable,
#               allow-stderr,
#               needs-root,
# Architecture: amd64
